<?php
/*
Copyright (c) 2006, John Stevens
All rights reserved.
E-mail : john AT jstevens DOT com

Non-commercial redistribution and use, with or without modification, 
is permitted provided that the following conditions are
met:

* Redistributions must retain the above copyright
notice, this list of conditions and the following disclaimer.

* The name of John Stevens may not
be used to endorse or promote products derived from this
software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, 
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
?>
<?PHP
include_once ("security_check.php");

$set_action = stripslashes(trim($_POST["set_action"]));
$set_server = stripslashes(trim($_POST["set_server"]));
$set_line = stripslashes(trim($_POST["set_line"]));
$set_filename = stripslashes(trim($_POST["set_filename"]));
$set_channel = stripslashes(trim($_POST["set_channel"]));
$set_start = stripslashes(trim($_POST["set_start"]));
if (($set_duration = stripslashes(trim($_POST["set_duration"]))) == "")
  $set_duration = $default_duration;
if (($set_padding = stripslashes(trim($_POST["set_padding"]))) == "")
  $set_padding = "Y";

$set_newname = stripslashes(trim($_POST["set_newname"]));
$set_newchannel = stripslashes(trim($_POST["set_newchannel"]));
$set_newstart = stripslashes(trim($_POST["set_newstart"]));
$set_pid = stripslashes(trim($_POST["set_pid"]));
if (($set_newduration = stripslashes(trim($_POST["set_newduration"]))) == "")
  $set_newduration = $default_duration;
if (($set_newpadding = stripslashes(trim($_POST["set_newpadding"]))) == "")
  $set_newpadding = $default_padding;
$set_newpadding = str_replace("~", "+", $set_newpadding);

$timer_submitted = false; // assume the timer submission fails
$failure_reason = "";

if ($set_action == "Delete" or $set_action == "Add" or $set_action == "Edit")
{
  if ($ftp = ftp_connect($FTPaddress[$set_server], $FTPport[$set_server]))
  {
    ftp_login($ftp, $FTPuser[$set_server], $FTPpw[$set_server]);
    ftp_chdir($ftp, $epg_timers_rem);
    if (ftp_size($ftp, $set_timers_tgd) > 0)
    {
      $get = ftp_get($ftp, $set_timers_loc . DIRECTORY_SEPARATOR . $set_timers_tgd, $set_timers_tgd,
        FTP_BINARY);
      $fp = fopen($set_timers_loc . DIRECTORY_SEPARATOR . $set_timers_tgd, "a");
    } else
    {
      $fp = fopen($set_timers_loc . DIRECTORY_SEPARATOR . $set_timers_tgd, "w");
    }

    if ($set_action == "Delete")
    {
      $values = explode("\t", $set_line);
      $set_channel = $chn_names[$values[1]];
      $set_start = substr($values[3], 0, 4) . "-" . substr($values[3], 4, 2) . "-" . substr($values[3], 6,
        2) . " " . substr($values[3], 9, 5);
      $set_duration = $values[4];
      $set_filename = substr_replace($values[0], "", -4);
      $set_padding = "D";
      // Delete the old timer
      fwrite($fp, tf_request_channel($set_server, $set_channel) . "\t" . $set_start . "\t" . $set_duration .
        "\t" . $set_filename . "\t\t\t\tD\t\n");
    } else
      if ($set_action == "Edit")
      {
        // Delete the old timer
        fwrite($fp, tf_request_channel($set_server, $set_channel) . "\t" . $set_start . "\t" . $set_duration .
          "\t" . $set_filename . "\t\t\t\tD\t\n");
      }
    if ($set_action == "Add" or $set_action == "Edit")
    {
      // Add the new timer
      fwrite($fp, tf_request_channel($set_server, $set_newchannel) . "\t" . $set_newstart . "\t" . $set_newduration .
        "\t" . $set_newname . "\t\t\t\t" . $set_newpadding . "\t\n");
    }
    fclose($fp);
    $timer_submitted = ftp_put($ftp, $set_timers_tgd, $set_timers_loc . "/" . $set_timers_tgd,
      FTP_BINARY);
    ftp_quit($ftp);
  } else
  {
    $failure_reason = "Cannot connect to $set_server";
  }
}
?>
